<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="systemName+'号'" prop="usercode">
        <el-input
            v-model="queryParams.usercode"
            :placeholder="'请输入'+systemName+'号'"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input
            v-model="queryParams.mobile"
            placeholder="请输入手机号"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="审核状态" prop="auditStatus">
        <el-select v-model="queryParams.auditStatus" placeholder="审核状态" clearable size="small">
          <el-option
              v-for="dict in auditStatusList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
              @keyup.enter.native="handleQuery"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="success"
            plain
            icon="el-icon-edit"
            size="mini"
            :disabled="multiple"
            @click="handleBatchAudit"
            v-hasPermi="['cai:dynamic:edit']"
        >批量审核通过
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            size="mini"
            :disabled="multiple"
            @click="handleBatchFail"
            v-hasPermi="['cai:dynamic:edit']"
        >批量审核驳回
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dynamicList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="id"/>
      <el-table-column :label="systemName+'号'" align="center" prop="usercode"/>
      <el-table-column label="手机号" align="center" prop="mobile"/>
      <el-table-column label="昵称" align="center" prop="nickname"/>
      <el-table-column label="头像" align="center" prop="avatar">
        <template v-slot="scope">
          <image-avatar :src="scope.row.avatar"/>
        </template>
      </el-table-column>
      <el-table-column label="审核状态" align="center" prop="auditStatus">
        <template v-slot="scope">
          <cai-dict-tag :options="auditStatusList" :value="scope.row.auditStatus"/>
        </template>
      </el-table-column>
      <el-table-column label="图片" align="center" prop="content" >
        <template v-slot="scope">
           <span v-for='val in scope.row.dynamicImageList'>
              <image-preview :src="val.url" height="40px" width="40px"  /> &nbsp;
<!--             <el-divider direction="vertical"></el-divider>-->
            </span>
        </template>
      </el-table-column>
      <el-table-column label="内容" align="center" prop="content" show-overflow-tooltip/>
      <el-table-column label="提交时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              v-if="scope.row.auditStatus === 1"
              @click="handleAuditSuccess(scope.row,2)"
              v-hasPermi="['cai:dynamic:edit']"
          >通过
          </el-button>
          <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              v-if="scope.row.auditStatus === 1"
              @click="handleAuditFail(scope.row)"
              v-hasPermi="['cai:dynamic:edit']"
          >不通过
          </el-button>
          <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['cai:dynamic:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script>
import {
  auditFailDynamic,
  auditSuccessDynamic,
  batchAuditDynamic, batchAuditDynamicFail,
  delDynamic,
  listDynamic,
  updateDynamic
} from "@/api/cai/dynamic";
import {auditStatusList} from "@/constant/statusMap";

export default {
  name: "Dynamic",
  data() {
    return {
      auditStatusList,
      systemName: process.env.VUE_APP_SYSTEM_HOME,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 主播动态表格数据
      dynamicList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        auditStatus: 1,
        mobile: undefined,
        usercode: undefined,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询主播动态列表 */
    getList() {
      this.loading = true;
      listDynamic(this.queryParams).then(response => {
        this.dynamicList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    handleAuditFail(row){
      this.$modal.confirm('是否确认不通过动态编号为"' + row.id + '"的数据项？').then(() => {
        this.loading = true;
        return auditFailDynamic({
          id: row.id,
        });
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleAuditSuccess(row){
      this.$modal.confirm('是否确认通过动态编号为"' + row.id + '"的数据项？').then(() => {
        this.loading = true;
        return auditSuccessDynamic({
          id: row.id,
        });
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleBatchAudit(){
      const ids = this.ids;
      this.$modal.confirm('是否确认批量审核通过动态编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return batchAuditDynamic({
          "ids": ids
        });
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleBatchFail(){
      const ids = this.ids;
      this.$modal.confirm('是否确认批量审核驳回动态编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return batchAuditDynamicFail({
          "ids": ids
        });
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除主播动态编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delDynamic(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
  }
};
</script>
